#!/usr/bin/perl

# this shows the games played by the best bots
#
#
#  Player        Bot A              Bot B          Score
#            Gold   Silv        Gold   Silv      BotA BotB
# --------------------------------------------------------
#          |      |           |      |
#  omar     * g 32   g 43       g 29   * g 45      1   1

require "playBestBots.pl";

###########################
# setup the functions we need from the gameroom

$curdir = `/bin/pwd`;
chomp $curdir;

chdir "gr";

require "html.pl";
require "cgi.pl";
require "data.pl";
require "cookie.pl";
require "email.pl";
require "gameserver.pl";
require "processinput.pl";
require "time.pl";

CgiPrintHeader();

#%c = &CookieRead();

%r = &DataGetSessionRec($c{sid});

chdir "$curdir";


############################
## check if the tournament is over
#$res = `/bin/grep "^result" rounds/tournState`;
#if ($res eq ""){
#  HtmlMessagePage("Tournament Not Over", "You cannot play the best bots until the tournament is over");
#  exit;
#}

# don't need this anymore since it is setup in the playBestBots.pl file
############################
## determine the two best bots
#if (! -e "playBestBots.cfg"){
#  HtmlMessagePage("Best Bots Needed", "The best bots have not been defined yet");
#  exit;
#}
#open(FH, "<playBestBots.cfg");
#$l = join('', <FH>);
#close FH;
#($bot1, $bot2) = ($l =~ m/(\w+)\s+(\w+)/s);
#
#($starttime) = ($l =~ m/\bstart\s*=\s*([^\n]+)\n/s);
#($endtime) = ($l =~ m/\bend\s*=\s*([^\n]+)\n/s);

if (($bot1 eq '') || ($bot2 eq '')){
  HtmlMessagePage("Best Bots Not Set", "The best bots have not been entered");
  exit;
}

###########################
# get the time period for the preChallange games 

if ($starttime eq ''){
  &HtmlErrorPage("Need Start Time", "Sorry no start time was given");
  exit;
}
if ($endtime eq ''){
  &HtmlErrorPage("Need End Time", "Sorry no end time was given");
  exit;
}

$startts = `date +%s -d "$starttime"`;
$endts = `date +%s -d "$endtime"`;

if ($startts eq ''){
  &HtmlErrorPage("Need Start Time", "Start time format seems bad.");
  exit;
}
if ($endts eq ''){
  &HtmlErrorPage("Need End Time", "End time format seems bad.");
  exit;
}

#$startts = $startts - 8*86400;


###########################
# get the game record against the tow bots during the time period

#DataGetPastGameRec("(wusername='$bot1' or wusername='$bot2' or busername='$bot1' or busername='$bot2') and ((wtype='b' and btype='h') or (wtype='h' and btype='b')) and rated=1 and startts>$startts and startts<$endts");

%g = DataGetPastGameRec("(wusername='$bot1' or wusername='$bot2' or busername='$bot1' or busername='$bot2') and rated=1 and startts>$startts and startts<$endts order by endts desc");

$sth = Db_getSth();

while($g{id}){
  my(%x);
  if ($g{wtype} eq 'b' and $g{btype} eq 'b'){ goto nextGame; }
  if ($g{wtype} eq 'h' and $g{btype} eq 'h'){ goto nextGame; }
#print "&nbsp; &nbsp; $g{id} $g{wusername} $g{busername}<br>\n";
  $p = 'w'; $b = 'b';
  if ($g{wtype} eq 'b'){
    $p = 'b'; $b = 'w';
  }
  if ($g{"${b}username"} eq $bot1){
    if ($b eq 'w'){ $i = 0; }
    else{ $i = 2; }
  }
  else{
    if ($b eq 'w'){ $i = 1; }
    else{ $i = 3; }
  }
  %x = %g;
  if ($x{result} eq 'd'){ $x{botwon} = 0.5; }
  else{
    $x{botwon} = (($x{result} eq 'w' and $x{wtype} eq 'b') or ($x{result} eq 'b' and $x{btype} eq 'b'))?1:0;
  }
  if ($x{botwon} == 1){ $x{star} = "*"; }
  if ($x{botwon} == 0.5){ $x{star} = "="; }
#print qq(    $g{"${p}username"} $i\n);
  $r{$g{"${p}username"}}[$i] = \%x;

################
# Show games in order like on Recent Commented Games page
################

  $wplayer = $g{wusername};
  $wplayer = qq(<a href="javascript:playerPage($g{wplayerid})"><b>$g{wusername}</b></a>);
  if ($g{wplayerid} != $in{id}){
#    $wplayer = qq(<a href="?id=$g{wplayerid}">$g{wusername}</a>);
    $wplayer = qq(<a href="javascript:playerPage($g{wplayerid})">$g{wusername}</a>);
  }
  $bplayer = $g{busername};
  $bplayer = qq(<a href="javascript:playerPage($g{bplayerid})"><b>$g{busername}</b></a>);
  if ($g{bplayerid} != $in{id}){
#    $bplayer = qq(<a href="?id=$g{bplayerid}">$g{busername}</a>);
    $bplayer = qq(<a href="javascript:playerPage($g{bplayerid})">$g{busername}</a>);
  }
#  $timecontrol = &makeTimeControlString($g{tcm}, $g{tcr}, $g{tcp}, $g{tcg});
  $timecontrol = $g{timecontrol};
  $rated = $g{rated}?"<b>R</b>":'';

  $wwins = "*";
  $bwins = "*";
  if ($g{result} eq "w"){ $bwins = ""; }
  if ($g{result} eq "b"){ $wwins = ""; }
  if ($g{result} eq "d"){ $wwins = "="; $bwins = "="; }

  $playedWhen = &getWhen($g{endts} - $r{timezone});

  $YLT = "YLT";
  if ($r{id} eq ""){ $YLT = "GMT"; }

  $comments = qq(<a href="/arimaa/gameroom/comments.cgi?gid=$g{id}" target=_blank class="v">add</a>);
  if ($g{commcount} > 0){
    $comments = qq(<a href="/arimaa/gameroom/comments.cgi?gid=$g{id}" target=_blank class="v">$g{commcount} $g{commusername}</a>);
  }

  $myGameRows .= <<EOM;
<tr>
  <td align=right>
    $wwins $wplayer
<br><font size=-1>$g{wrating} &nbsp; $g{wcountry}</font>
  </td>
  <td align=center>
    <font size=1>$rated <a href="/arimaa/gameroom/timecontrol.cgi?tc=$timecontrol" target=_blank> $timecontrol</a></font><br>
<table background="/arimaa/graphics/BoardWithPiecesIcon2.jpg" width=50 height=50 border=0 cellspacing=0 cellpadding=0>
  <tr>
    <td >
<!--
<a href="/arimaa/games/jsShowGame.cgi?gid=$g{id}&s=w" target=replay$g{id} >
<a href="/arimaa/gameroom/opengamewin.cgi?gameid=$g{id}&side=w&role=v" target=replay$g{id} >
-->
<a href="javascript:openGame('$g{id}','v','w')" >
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
    <td >
<!--
<a href="/arimaa/games/jsShowGame.cgi?gid=$g{id}&s=b" target=replay$g{id}>
<a href="/arimaa/gameroom/opengamewin.cgi?gameid=$g{id}&side=b&role=v" target=replay$g{id} >
-->
<a href="javascript:openGame('$g{id}','v','b')" >
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
  </tr>
</table>
  </td>
  <td align=left>
    $bplayer $bwins
<br><font size=-1>$g{bcountry} &nbsp; $g{brating}</font>
  </td>
  <td align=right>
    &nbsp; &nbsp;
  </td>
  <td align=center>
    $g{termination}
  </td>
  <td align=right>
    $g{plycount}
  </td>
  <td align=right>
    &nbsp; &nbsp;
  </td>
  <td align=left>
    $playedWhen $YLT $gts
  </td>
  <td align=right>
    &nbsp; &nbsp;
  </td>
  <td align=left>
    $comments
  </td>
<!--
-->
</tr>
EOM


nextGame:
  %g = DataGetNextRec($sth);
}

if ($myGameRows){
  $myGames = <<EOM;
<script>
function openGame(id, role, side){
    open('/arimaa/gameroom/opengamewin.cgi?client=1&gameid='+id+'&role='+role+'&side='+side,'','toolbar=no,width=350,height=250,scrollbars=yes,directories=no,location=no,menubar=no,personalbar=no,resizable=yes');
    void('');
}

function reasonCodes(){
  open('/arimaa/gameroom/reasonCodes.html','','toolbar=no,width=650,height=450,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
}

function playerPage(id){
    open('/arimaa/gameroom/playerpage.cgi?id='+id,'','toolbar=yes,xwidth=650,xheight=550,scrollbars=yes,directories=no,location=no,menubar=no,personalbar=no,resizable=yes');
//    window.location = 'playerpage.cgi?id='+id;
    void('');
}
</script>
<table border=0>
  <tr>
    <td colspan=3 align=center>
<b>
<font size=-2>
Click on the board to view the game
</font>
</b>
    </td>
  </tr>
  <tr>
    <td align=right>
      Gold
    </td>
    <td align=center>
      &nbsp;
    </td>
    <td align=left>
      Silver
    </td>
    <td align=left>

    </td>
    <td align=left>
      <a href="javascript:reasonCodes();">Reason</a>
    </td>
    <td align=left>
      Moves
    </td>
    <td align=left>

    </td>
    <td align=left>
      Finished on
    </td>
    <td align=left>

    </td>
    <td align=left>
      Comments
    </td>
<!--
-->
  </tr>
  $myGameRows
</table>
EOM
}

#print "\n\n";

while(($p,$v) = each(%r)){
  
  $bot1t = 0;
  $bot2t = 0;
  if ($r{$p}[0] and $r{$p}[1]){
    $bot1t += $r{$p}[0]->{botwon};
    $bot2t += $r{$p}[1]->{botwon};
  }
  if ($r{$p}[2] and $r{$p}[3]){
    $bot1t += $r{$p}[2]->{botwon};
    $bot2t += $r{$p}[3]->{botwon};
  }
  $bot1n += $bot1t;
  $bot2n += $bot2t;

  $row = <<EOM;
<tr>
<td>$p</p>
<td><font color=red>$r{$p}[0]->{star}</font> <a target=_blank href="/arimaa/gameroom/comments.cgi?gid=$r{$p}[0]->{id}">$r{$p}[0]->{termination} $r{$p}[0]->{plycount}</a></td>
<td><font color=red>$r{$p}[2]->{star}</font> <a target=_blank href="/arimaa/gameroom/comments.cgi?gid=$r{$p}[2]->{id}">$r{$p}[2]->{termination} $r{$p}[2]->{plycount}</a></td>
<td>$bot1t</td>
<td><font color=red>$r{$p}[1]->{star}</font> <a target=_blank href="/arimaa/gameroom/comments.cgi?gid=$r{$p}[1]->{id}">$r{$p}[1]->{termination} $r{$p}[1]->{plycount}</a></td>
<td><font color=red>$r{$p}[3]->{star}</font> <a target=_blank href="/arimaa/gameroom/comments.cgi?gid=$r{$p}[3]->{id}">$r{$p}[3]->{termination} $r{$p}[3]->{plycount}</a></td>
<td>$bot2t</td>
</tr>
EOM

  $rows .= $row;

#  print "$p $r{$p}[0]->{id} $r{$p}[1]->{id} $r{$p}[2]->{id} $r{$p}[3]->{id} \n";
#  print "$p $r{$p}[0]->{botwon} $r{$p}[1]->{botwon} $r{$p}[2]->{botwon} $r{$p}[3]->{botwon}   tot= $bot1t  $bot2t \n";
}

$page = <<EOM;

<p align=center>
The bot with the higher score will go on to play in the challenge match.
<br>
Games where only one of the bots were played are not counted.
<br>
Games where the bot won are marked with a star <font color=red>*</font>
</p>

<center>
<table border=1>
  <tr>
<td><b>Player</b></td>
<td><b>$bot1<br>Gold</b></td>
<td><b>$bot1<br>Silver</b></td>
<td><b>$bot1<br>Points</b></td>
<td><b>$bot2<br>Gold</b></td>
<td><b>$bot2<br>Silver</b></td>
<td><b>$bot2<br>Points</b></td>
  </tr>
$rows
  <tr>
<td></td>
<td></td>
<td></td>
<td><b>$bot1n</b></td>
<td></td>
<td></td>
<td><b>$bot2n</b></td>
  </tr>
</table>

<p>
$myGames

</center>
EOM

HtmlMessagePage("Bot Scores", $page);


exit;

